<?php
if (!$session->chkLevel(IS_DOMAIN_OWNER)) {
	error(lmsg('__perm_denied'));
	go_to('/', 'top');
}

$session->delParam(SPN_DATABASE_USER_ID);

$cl_id = $session->getParam(SPN_CLIENT_ID);
if (!$cl_id && !$session->isAdmin()) {
	$session->destroy();
	go_to('/logout.php3');
}

$dom_id = $session->getParam(SPN_DOMAIN_ID) + 0;
if (!$dom_id && !$session->isAdmin()) {
	error(lmsg('__dom_id_is_undefined'));
	go_to_uplevel();
}

if (!$db_id = (int)get_gpc('db_id'))
	$db_id = $session->getParam(SPN_DATABASE_ID) + 0;

$db_id += 0;
if ($db_id <= 0) {
	error(lmsg('db__db_id_undefined'));
	go_to_uplevel();
}

require_once('class.DataBase.php3');

$db = objectMaker('Database', $db_id);
if ($db->error())
	throw new PleskFatalException('Unable to create database object: ' . $db->getErrorMsg());

require_once('class.DataBase.php3');
require_once('DatabaseServerManager.php');

$serverManager = DatabaseServerManager::getInstance();
$dbManager = $serverManager->getDatabaseManager($serverManager->getServer($db->getAttr('db_server_id')));

if (!$dom_id) {
	$dom_id = $db->getAttr('dom_id');
	$session->putParam(SPN_DOMAIN_ID, $dom_id);
}

require_once('class.Domain.php');
$domain = objectMaker('Domain', $dom_id);
if ($domain->error())
	psaerror('Unable to create Domain object: ' . $domain->getErrorMsg());

/// Check for ownership
require_once('SiteApps/sapp_constants.php');
$query = 'SELECT d.displayName, rs.app_id FROM data_bases db LEFT JOIN ' . SITEAPP_RESOURCES_TABLE . ' rs ON rs.type="' . SITEAPP_RESOURCE_DATABASE . '" AND rs.res_id=db.id, domains d WHERE db.id="' . db_escape_string($db_id) . '" AND db.dom_id = d.id AND db.dom_id="' . db_escape_string($dom_id) . '"';
$res = db_query($query);

if (!(list($domainDisplayName, $app_id) = db_fetch_row($res))) {
	error(lmsg('class_db__db_not_exist_for_curr_dom'));
	go_to_uplevel();
}

//if ($app_id > 0)
//	psaerror('Unable to edit linked resource');

$session->putParam(SPN_DATABASE_ID, $db_id);
$cmd = get_gpc('cmd', '');

if ($cmd == 'remove') {
	lock_level(SEM_DATABASE);
}

require_once('class.DataBaseUsersList.php3');
$list = new DataBaseUsersList($db_id);
if ($list->error())
	psaerror('Unable to create database users list object: ' . $list->getErrorMsg());


$dbWebAdminURL = false;
$db_usr1_found = false;

$db_usr1_pass_type = 'plain';

$def_user = $dbManager->getDefaultUser($db);
if ($def_user) {
	$db_usr1_found = true;
	$db_usr1_login = $def_user->getLogin();
}

if (($def_user) && ($def_user->getPasswordType() == 'crypt')) {
	$db_usr1_pass_type = 'crypt';
}

switch ($cmd) {
	case 'remove':

		if (!$db_usr1_found) {
			unlock_level(SEM_DATABASE);
			error(lmsg('db_edit__no_users'));
			$cmd = '';
			break;
		}

		if (!get_gpc('removeConfirmed'))
			break;

		if (!$del = get_gpc('del') or !is_array($del)) {
			error(lmsg('db__select_db_users_for_remove'));
			$cmd = '';
			break;
		}

		$list->remove($del);

		break;

	case 'phpAdmin':

		try {
			$dbManager->setWebAdminParams($db);
			$db_usr1_found = true;
		} catch (PleskUserDBException $e) {
			if (($e->getCategory() == 'no_db_users') && ($e->getCode() == 1)) {
				error(lmsg('db_edit__no_users'));
				if (wizard_get())
					go_to_uplevel();
				break;
			} else
				throw $e;
		}

		$def_user = $dbManager->getDefaultUser($db);

		// get crypted password form form and redefine it in session
		if (($def_user) && ($def_user->getPasswordType() == 'crypt')) {
			$password = get_gpc('db_password', '');
			$session->putParam(SPN_PHP_ADMIN_DB_PASS, $password);
		}

		$dbWebAdminURL = $dbManager->getWebAdminURL();

		setcookie('phpMyAdmin', '', time() - 3600, '/');

		if (wizard_get()) {
			echo '<script>window.open("' . $dbWebAdminURL . '", "", "width=700,height=600,innerWidth=700,innerHeight=600,toolbar=yes,personalbar=no,locationbar=no,statusbar=no,scrollbars=yes,resizable=yes");</script>';
			wizard_dispatch_next();
		}

		break;

	case 'set_default':

		$del = get_gpc('del');

		if (!is_array($del) || empty($del)) {
			error(lmsg('dbuser__select_user_for_set_default'));
			break;
		}

		$new_def_user = objectMaker('dbUser', $del[0]);
		if ($new_def_user->error())
			throw new PleskFatalException($new_def_user->getErrorMsg());

		$dbManager->setDefaultUser($db, $new_def_user);

		$db_usr1_pass_type = 'plain';

		$db_usr1_found = true;
		$db_usr1_login = $new_def_user->getLogin();

		if ($new_def_user->getPasswordType() == 'crypt')
			$db_usr1_pass_type = 'crypt';

		break;

	default:
		if (!$list->setFSP($cmd))
			psaerror('DataBaseUsersList::setFSP() failed: ' . $list->getErrorMsg());
		break;
}

if ($cmd == 'remove')
	unlock_level(SEM_DATABASE);

if ($list->error())
	error($list->getErrorMsg());

$list->init();

if ($list->error())
	error($list->getErrorMsg());

// PRINT FORM

require_once('class.DBEditForm.php');
$form = new DBEditForm();
$form->define();
$form->assign($serverManager, $domain, $db, $list, $dbWebAdminURL, $db_usr1_found && ('crypt' === $db_usr1_pass_type) ? $db_usr1_login : false);
$form->parse();
$form->FastPrint();
?>
