<?php

if (!$session->chkLevel(IS_ADMIN))
	throw new PleskUserException(lmsg('__perm_denied'));
	
require_once('DatabaseServerManager.php');

$listCommand = '';
$dbWebAdminURL = false;
$cmd = get_gpc('cmd');
switch ($cmd)
{
case 'remove':
	$del = get_gpc('del');
	if (is_array($del) && sizeof($del)) {
		$serverManager = DatabaseServerManager::getInstance();
		if (get_gpc('removeConfirmed')) {
			foreach ($del as $item)
				$serverManager->deleteServer($serverManager->getServer((int)$item));
		} else {
			require_once('class.RemoveForm.php');

			$list = '<ul>';
			foreach ($del as $item) {
				$id = (int)$item;
				$list .=  "<input type='hidden' name='del[]' value='$id'>";
				$server = $serverManager->getServer($id);
				if ($server->error())
					throw new PleskFatalException($server->getErrorMsg());
				$list .= '<li>';
				$list .= safetyhtml($server->getAttr('host') . ':' . $server->getAttr('port'));
				$list .= '</li>';
			}
			$list .= '</ul>';
			$vars = array(
				'PAGE_TITLE' 		=> lmsg('database_servers_form__remove_title'),
				'UPDATE_BUTTON'		=> RemoveForm::getUpdateButton(null, 'confirm_submit(); return false'),
				'TEXT_AGREEMENT'	=> lmsg('__confirm_removal'),
				'LIST'				=> $list,
			);

			$myRemoveForm = new RemoveForm($vars);
			$myRemoveForm->FastPrint();
			exit();
		}
	} else
		error(lmsg('database_servers_form__remove_empty_selection'));
	break;
	
case 'dbwebadmin':
	
	$db_server_id = (int)get_gpc('db_server_id', 0);
	if ($db_server_id <= 0)
		throw new PleskFatalException('Database server id is undefined');

	$serverManager = DatabaseServerManager::getInstance();
	$server = $serverManager->getServer($db_server_id);
	$dbManager = $serverManager->getDatabaseManager($server);
	
	if (!$serverManager->isTypeAllowedByKey($server->getAttr('type'))) {
		error(lmsg('__database_type_not_supported_by_key'));
		$dbWebAdminURL = false;
		break;
	}
	
	$conn_exception = $dbManager->testConnection();
	if (!$conn_exception){
		$dbManager->setWebAdminParams();
		$dbWebAdminURL = $dbManager->getWebAdminURL();
	} else {
		$dbWebAdminURL = false;
		error($conn_exception->getMessage());
	}

	setcookie('phpMyAdmin', '', time() - 3600, '/');
	
	break;	

default:
	$listCommand = $cmd;
	break;
}

require_once('DatabaseServersForm.php');
$form = new DatabaseServersForm;
$form->define();
$form->assign($listCommand, $dbWebAdminURL);
$form->parse();
$form->FastPrint();
?>
